﻿using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using GHIElectronics.NETMF.FEZ;
using GHIElectronics.NETMF.Hardware;

namespace Telemetre
{
    public class Program
    {
        public static void Main()
        {
            // Constantes
            const Single Kcan = 310.30303F, S = -10.18e-3F, I0 = 21.34e-3F;
            const UInt16 R = 165;
 
            // Variables
            UInt16 N=0;
            Single Hauteur = 0, I = 0;

            // Configuration des entrées / sorties 
            // Entrées
            AnalogIn In_U = new AnalogIn(AnalogIn.Pin.Ain3);
            // Sorties 
            FEZ_Components.SerialELCD162 LCD = new FEZ_Components.SerialELCD162((byte)(FEZ_Pin.Digital.Di1));
            PWM Buzzer = new PWM(PWM.Pin.PWM5);

            while (true)
            {
                // Lire
                N = (UInt16)In_U.Read();
                  
                // Traiter
                // Programme de base
                Hauteur = 100*(N/(Kcan*R*S)-(I0/S));
                I = N / (Kcan * R);

                // Modification 1
                if (Hauteur < 20.0)
                {
                    Buzzer.Set(500,50);                   
                }
                else if (Hauteur > 170.0)
                {
                    Buzzer.Set(1000,50);
                }
                else {
                    Buzzer.Set(false);
                }

                // Ecrire
                Debug.Print("I= " + (1000 * I).ToString("N1") + "mA" + "   Hauteur= " + Hauteur.ToString("N1") + "cm");
                LCD.ClearScreen();
                LCD.PutString("I= " + (1000 * I).ToString("N1") + "mA");
                LCD.SetCursor(0, 1);
                LCD.PutString("H= " + Hauteur.ToString("N1") + "cm");

                Thread.Sleep(1000);
            }
        }
    }
}
